clang 8.0.0

Public Member Functions | Static Public Member Functions | List of all members
clang::CaseStmt Class Referencefinal

CaseStmt - Represent a case statement. More...

`#include "clang/AST/Stmt.h"`

Inheritance diagram for clang::CaseStmt:
[legend]
Collaboration diagram for clang::CaseStmt:
[legend]

## Public Member Functions
bool | caseStmtIsGNURange () const
| True if this case statement is of the form case LHS ... More...
SourceLocation | getCaseLoc () const
void | setCaseLoc (SourceLocation L)
SourceLocation | getEllipsisLoc () const
| Get the location of the ... in a case statement of the form LHS ... RHS. More...
void | setEllipsisLoc (SourceLocation L)
| Set the location of the ... More...
Expr * | getLHS ()
const Expr * | getLHS () const
void | setLHS (Expr *Val)
Expr * | getRHS ()
const Expr * | getRHS () const
void | setRHS (Expr *Val)
Stmt * | getSubStmt ()
const Stmt * | getSubStmt () const
void | setSubStmt (Stmt *S)
SourceLocation | getBeginLoc () const
SourceLocation | getEndLoc () const LLVM_READONLY
child_range | children ()
Public Member Functions inherited from clang::SwitchCase
const SwitchCase * | getNextSwitchCase () const
SwitchCase * | getNextSwitchCase ()
void | setNextSwitchCase (SwitchCase *SC)
SourceLocation | getKeywordLoc () const
void | setKeywordLoc (SourceLocation L)
SourceLocation | getColonLoc () const
void | setColonLoc (SourceLocation L)
Stmt * | getSubStmt ()
const Stmt * | getSubStmt () const
SourceLocation | getBeginLoc () const
SourceLocation | getEndLoc () const LLVM_READONLY
Public Member Functions inherited from clang::Stmt
void * | operator new (size_t bytes, const ASTContext &C, unsigned alignment=8)
void * | operator new (size_t bytes, const ASTContext *C, unsigned alignment=8)
void * | operator new (size_t bytes, void *mem) noexcept
void | operator delete (void *, const ASTContext &, unsigned) noexcept
void | operator delete (void *, const ASTContext *, unsigned) noexcept
void | operator delete (void *, size_t) noexcept
void | operator delete (void *, void *) noexcept
| Stmt (StmtClass SC)
StmtClass | getStmtClass () const
const char * | getStmtClassName () const
SourceRange | getSourceRange () const LLVM_READONLY
| SourceLocation tokens are not useful in isolation - they are low level value objects created/interpreted by SourceManager. More...
SourceLocation | getBeginLoc () const LLVM_READONLY
SourceLocation | getEndLoc () const LLVM_READONLY
void | dump () const
| Dumps the specified AST fragment and all subtrees to `llvm::errs()`. More...
void | dump (SourceManager &SM) const
void | dump (raw_ostream &OS, SourceManager &SM) const
void | dump (raw_ostream &OS) const
int64_t | getID (const ASTContext &Context) const
void | dumpColor () const
| dumpColor - same as dump(), but forces color highlighting. More...
void | dumpPretty (const ASTContext &Context) const
| dumpPretty/printPretty - These two methods do a "pretty print" of the AST back to its original source language syntax. More...
void | printPretty (raw_ostream &OS, PrinterHelper *Helper, const PrintingPolicy &Policy, unsigned Indentation=0, StringRef NewlineSymbol="\, const ASTContext *Context=nullptr) const
void | viewAST () const
| viewAST - Visualize an AST rooted at this Stmt* using GraphViz. More...
Stmt * | IgnoreImplicit ()
| Skip past any implicit AST nodes which might surround this statement, such as ExprWithCleanups or ImplicitCastExpr nodes. More...
const Stmt * | IgnoreImplicit () const
Stmt * | IgnoreContainers (bool IgnoreCaptured=false)
| Skip no-op (attributed, compound) container stmts and skip captured stmt at the top, if IgnoreCaptured is true. More...
const Stmt * | IgnoreContainers (bool IgnoreCaptured=false) const
const Stmt * | stripLabelLikeStatements () const
| Strip off all label-like statements. More...
Stmt * | stripLabelLikeStatements ()
child_range | children ()
const_child_range | children () const
child_iterator | child_begin ()
child_iterator | child_end ()
const_child_iterator | child_begin () const
const_child_iterator | child_end () const
void | Profile (llvm::FoldingSetNodeID &ID, const ASTContext &Context, bool Canonical) const
| Produce a unique representation of the given statement. More...
void | ProcessODRHash (llvm::FoldingSetNodeID &ID, ODRHash &Hash) const
| Calculate a unique representation for a statement that is stable across compiler invocations. More...

## Static Public Member Functions
static CaseStmt * | Create (const ASTContext &Ctx, Expr *lhs, Expr *rhs, SourceLocation caseLoc, SourceLocation ellipsisLoc, SourceLocation colonLoc)
| Build a case statement. More...
static CaseStmt * | CreateEmpty (const ASTContext &Ctx, bool CaseStmtIsGNURange)
| Build an empty case statement. More...
static bool | classof (const Stmt *T)
Static Public Member Functions inherited from clang::SwitchCase
static bool | classof (const Stmt *T)
Static Public Member Functions inherited from clang::Stmt
static void | addStmtClass (const StmtClass s)
static void | EnableStatistics ()
static void | PrintStats ()

## Additional Inherited Members
Public Types inherited from clang::Stmt
enum | StmtClass { NoStmtClass = 0 }
using | child_iterator = StmtIterator
| Child Iterators: All subclasses must implement 'children' to permit easy iteration over the substatements/subexpessions of an AST node. More...
using | const_child_iterator = ConstStmtIterator
using | child_range = llvm::iterator_range< child_iterator >
using | const_child_range = llvm::iterator_range< const_child_iterator >
Protected Types inherited from clang::Stmt
enum | { NumStmtBits = 8 }
enum | { NumExprBits = NumStmtBits + 9 }
enum | APFloatSemantics { IEEEhalf, IEEEsingle, IEEEdouble, x87DoubleExtended, IEEEquad, PPCDoubleDouble }
enum | { NumCallExprBits = 32 }
enum | { NumOverloadExprBits = NumExprBits + 1 }
Protected Member Functions inherited from clang::SwitchCase
| SwitchCase (StmtClass SC, SourceLocation KWLoc, SourceLocation ColonLoc)
| SwitchCase (StmtClass SC, EmptyShell)
Protected Member Functions inherited from clang::Stmt
void * | operator new (size_t bytes) noexcept
void | operator delete (void *data) noexcept
| Stmt (StmtClass SC, EmptyShell)
| Construct an empty statement. More...
Protected Attributes inherited from clang::SwitchCase
SourceLocation | ColonLoc
| The location of the ":". More...
SwitchCase * | NextSwitchCase = nullptr
| A pointer to the following CaseStmt or DefaultStmt class, used by SwitchStmt. More...
Protected Attributes inherited from clang::Stmt
union {
StmtBitfields StmtBits
NullStmtBitfields NullStmtBits
CompoundStmtBitfields CompoundStmtBits
LabelStmtBitfields LabelStmtBits
AttributedStmtBitfields AttributedStmtBits
IfStmtBitfields IfStmtBits
SwitchStmtBitfields SwitchStmtBits
WhileStmtBitfields WhileStmtBits
DoStmtBitfields DoStmtBits
ForStmtBitfields ForStmtBits
GotoStmtBitfields GotoStmtBits
ContinueStmtBitfields ContinueStmtBits
BreakStmtBitfields BreakStmtBits
ReturnStmtBitfields ReturnStmtBits
SwitchCaseBitfields SwitchCaseBits
ExprBitfields ExprBits
PredefinedExprBitfields PredefinedExprBits
DeclRefExprBitfields DeclRefExprBits
FloatingLiteralBitfields FloatingLiteralBits
StringLiteralBitfields StringLiteralBits
CharacterLiteralBitfields CharacterLiteralBits
UnaryOperatorBitfields UnaryOperatorBits
UnaryExprOrTypeTraitExprBitfields UnaryExprOrTypeTraitExprBits
ArraySubscriptExprBitfields ArraySubscriptExprBits
CallExprBitfields CallExprBits
MemberExprBitfields MemberExprBits
CastExprBitfields CastExprBits
BinaryOperatorBitfields BinaryOperatorBits
InitListExprBitfields InitListExprBits
ParenListExprBitfields ParenListExprBits
PseudoObjectExprBitfields PseudoObjectExprBits
CXXOperatorCallExprBitfields CXXOperatorCallExprBits
CXXBoolLiteralExprBitfields CXXBoolLiteralExprBits
CXXNullPtrLiteralExprBitfields CXXNullPtrLiteralExprBits
CXXThisExprBitfields CXXThisExprBits
CXXThrowExprBitfields CXXThrowExprBits
CXXDefaultArgExprBitfields CXXDefaultArgExprBits
CXXDefaultInitExprBitfields CXXDefaultInitExprBits
CXXScalarValueInitExprBitfields CXXScalarValueInitExprBits
CXXNewExprBitfields CXXNewExprBits
CXXDeleteExprBitfields CXXDeleteExprBits
TypeTraitExprBitfields TypeTraitExprBits
DependentScopeDeclRefExprBitfields DependentScopeDeclRefExprBits
CXXConstructExprBitfields CXXConstructExprBits
ExprWithCleanupsBitfields ExprWithCleanupsBits
CXXUnresolvedConstructExprBitfields CXXUnresolvedConstructExprBits
CXXDependentScopeMemberExprBitfields CXXDependentScopeMemberExprBits
OverloadExprBitfields OverloadExprBits
UnresolvedLookupExprBitfields UnresolvedLookupExprBits
UnresolvedMemberExprBitfields UnresolvedMemberExprBits
CXXNoexceptExprBitfields CXXNoexceptExprBits
SubstNonTypeTemplateParmExprBitfields SubstNonTypeTemplateParmExprBits
CoawaitExprBitfields CoawaitBits
ObjCIndirectCopyRestoreExprBitfields ObjCIndirectCopyRestoreExprBits
OpaqueValueExprBitfields OpaqueValueExprBits
}; |

## Detailed Description

CaseStmt - Represent a case statement.

It can optionally be a GNU case statement of the form LHS ... RHS representing a range of cases.

Definition at line 1394 of file Stmt.h.

## Member Function Documentation

## ◆ caseStmtIsGNURange()

bool clang::CaseStmt::caseStmtIsGNURange | ( |  | ) | const
| inline

True if this case statement is of the form case LHS ...

RHS, which is a GNU extension. In this case the RHS can be obtained with getRHS() and the location of the ellipsis can be obtained with getEllipsisLoc().

Definition at line 1463 of file Stmt.h.

Referenced by clang::TextNodeDumper::VisitCaseStmt().

## ◆ children()

child_range clang::CaseStmt::children | ( |  | ) |
| inline

Definition at line 1537 of file Stmt.h.

## ◆ classof()

static bool clang::CaseStmt::classof | ( | const Stmt * | T | ) |
| inline static

Definition at line 1532 of file Stmt.h.

References clang::Stmt::getStmtClass().

## ◆ Create()

CaseStmt * CaseStmt::Create | ( | const ASTContext & | Ctx,
|  | Expr * | lhs,
|  | Expr * | rhs,
|  | SourceLocation | caseLoc,
|  | SourceLocation | ellipsisLoc,
|  | SourceLocation | colonLoc
| ) |  |
| static

Build a case statement.

Definition at line 1080 of file Stmt.cpp.

References clang::ASTContext::Allocate().

Referenced by clang::Sema::ActOnCaseStmt().

## ◆ CreateEmpty()

CaseStmt * CaseStmt::CreateEmpty | ( | const ASTContext & | Ctx,
|  | bool | CaseStmtIsGNURange
| ) |  |
| static

Build an empty case statement.

Definition at line 1091 of file Stmt.cpp.

References clang::ASTContext::Allocate(), and clang::Stmt::Stmt().

## ◆ getBeginLoc()

SourceLocation clang::CaseStmt::getBeginLoc | ( |  | ) | const
| inline

Definition at line 1522 of file Stmt.h.

## ◆ getCaseLoc()

SourceLocation clang::CaseStmt::getCaseLoc | ( |  | ) | const
| inline

Definition at line 1465 of file Stmt.h.

## ◆ getEllipsisLoc()

SourceLocation clang::CaseStmt::getEllipsisLoc | ( |  | ) | const
| inline

Get the location of the ... in a case statement of the form LHS ... RHS.

Definition at line 1469 of file Stmt.h.

## ◆ getEndLoc()

SourceLocation clang::CaseStmt::getEndLoc | ( |  | ) | const
| inline

Definition at line 1523 of file Stmt.h.

References clang::Stmt::getEndLoc(), and getSubStmt().

## ◆ getLHS() [1/2]

Expr* clang::CaseStmt::getLHS | ( |  | ) |
| inline

Definition at line 1483 of file Stmt.h.

Referenced by clang::Sema::CodeCompleteCase(), EvaluateSwitch(), clang::ento::ExprEngine::processSwitch(), and shouldAddCase().

## ◆ getLHS() [2/2]

const Expr* clang::CaseStmt::getLHS | ( |  | ) | const
| inline

Definition at line 1487 of file Stmt.h.

## ◆ getRHS() [1/2]

Expr* clang::CaseStmt::getRHS | ( |  | ) |
| inline

Definition at line 1495 of file Stmt.h.

Referenced by EvaluateSwitch(), clang::ento::ExprEngine::processSwitch(), and shouldAddCase().

## ◆ getRHS() [2/2]

const Expr* clang::CaseStmt::getRHS | ( |  | ) | const
| inline

Definition at line 1501 of file Stmt.h.

## ◆ getSubStmt() [1/2]

Stmt* clang::CaseStmt::getSubStmt | ( |  | ) |
| inline

Definition at line 1513 of file Stmt.h.

Referenced by getEndLoc(), and shouldAddCase().

## ◆ getSubStmt() [2/2]

const Stmt* clang::CaseStmt::getSubStmt | ( |  | ) | const
| inline

Definition at line 1514 of file Stmt.h.

## ◆ setCaseLoc()

void clang::CaseStmt::setCaseLoc | ( | SourceLocation | L | ) |
| inline

Definition at line 1466 of file Stmt.h.

## ◆ setEllipsisLoc()

void clang::CaseStmt::setEllipsisLoc | ( | SourceLocation | L | ) |
| inline

Set the location of the ...

in a case statement of the form LHS ... RHS. Assert that this case statement is of this form.

Definition at line 1476 of file Stmt.h.

## ◆ setLHS()

void clang::CaseStmt::setLHS | ( | Expr * | Val | ) |
| inline

Definition at line 1491 of file Stmt.h.

## ◆ setRHS()

void clang::CaseStmt::setRHS | ( | Expr * | Val | ) |
| inline

Definition at line 1507 of file Stmt.h.

## ◆ setSubStmt()

void clang::CaseStmt::setSubStmt | ( | Stmt * | S | ) |
| inline

Definition at line 1518 of file Stmt.h.

The documentation for this class was generated from the following files:

- include/clang/AST/Stmt.h
- lib/AST/Stmt.cpp